/*
 * soft_i2c_slave.h
 *
 *  Created on: Oct 16, 2024
 *      Author: true
 */

#ifndef USER_COMM_SOFT_I2C_SLAVE_H_
#define USER_COMM_SOFT_I2C_SLAVE_H_



#include <stdint.h>


typedef struct I2CSoftSlave {
    uint8_t addr;
    uint8_t addr2;
    uint16_t bit_time;
    uint8_t (*rd_cb)(uint8_t addr, uint8_t *data);      // return 0 to ACK
    void    (*wr_cb)(uint8_t addr, uint8_t data);
} I2CSoftSlave;


enum I2CSoftSlave_Error {
    // standard responses
    I2CSS_OK,
    I2CSS_ADDR_NO_MATCH,
    // errors
    I2CSS_START_SCL_NOT_LOW         = -1,
    I2CSS_ADDR_READ_ERROR           = -2,   // could be timeout, start or stop condition detected
    I2CSS_ADDR_READ_TIMEOUT         = -3,
    I2CSS_ADDR_READ_LASTBIT_TIMEOUT = -4,
    I2CSS_ACK_ERROR                 = -5,   // could be timeout, start or stop condition detected
    I2CSS_ACK_TIMEOUT               = -6,
};



int8_t i2css_blocking(struct I2CSoftSlave *slave);



#endif /* USER_COMM_SOFT_I2C_SLAVE_H_ */
