/*
 * rgbled.h
 *
 *  Created on: Oct 13, 2024
 *      Author: true
 */

#ifndef USER_LED_RGBLED_H_
#define USER_LED_RGBLED_H_



#include <stdint.h>

#include "hsv2rgb.h"

#include "../comm/i2c.h"

#include "../hw/ch32sub.h"



#define RGBLED_COUNT            12



typedef struct LedProgram {
    char *name;
    void (*prog)(uint8_t *, uint16_t);
} LedProgram;



extern const uint8_t rgb_map[RGBLED_COUNT];
extern const LedProgram rgb_pgm[6];

extern struct color_hsv hsv_out[RGBLED_COUNT];



void rgbled_init();

void rgbled_send();
void rgbled_runprog(uint8_t tick_ctr);



#endif /* USER_LED_RGBLED_H_ */

